Infra: Add 2n-xn2
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
202     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
203     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
204     # Directories created if not present:
205     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
206     # Functions called:
207     # - die - Print to stderr and exit.
208
209     set -exuo pipefail
210
211     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
212         die "Some error during locating of this source file."
213     }
214     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
215         die "Some error during dirname call."
216     }
217     # Current working directory could be in a different repo, e.g. VPP.
218     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
219     relative_csit_dir=$(git rev-parse --show-toplevel) || {
220         die "Git rev-parse failed."
221     }
222     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
223     popd || die "Popd failed."
224     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
225         die "Readlink failed."
226     }
227     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
228         die "Readlink failed."
229     }
230     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
231         die "Readlink failed."
232     }
233     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
234         die "Readlink failed."
235     }
236     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
237         die "Readlink failed."
238     }
239     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
240         die "Readlink failed."
241     }
242
243     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
244         die "Readlink failed."
245     }
246     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
247     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
248         die "Readlink failed."
249     }
250     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
251     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
252         die "Readlink failed."
253     }
254     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
255 }
256
257
258 function compose_pybot_arguments () {
259
260     # Variables read:
261     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
262     # - DUT - CSIT test/ subdirectory, set while processing tags.
263     # - TAGS - Array variable holding selected tag boolean expressions.
264     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
265     # - TEST_CODE - The test selection string from environment or argument.
266     # Variables set:
267     # - PYBOT_ARGS - String holding part of all arguments for pybot.
268     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
269
270     set -exuo pipefail
271
272     # No explicit check needed with "set -u".
273     PYBOT_ARGS=("--loglevel" "TRACE")
274     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
275
276     case "${TEST_CODE}" in
277         *"device"*)
278             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
279             ;;
280         *"perf"*)
281             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
282             ;;
283         *)
284             die "Unknown specification: ${TEST_CODE}"
285     esac
286
287     EXPANDED_TAGS=()
288     for tag in "${TAGS[@]}"; do
289         if [[ ${tag} == "!"* ]]; then
290             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
291         else
292             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
293         fi
294     done
295 }
296
297
298 function copy_archives () {
299
300     # Create additional archive if workspace variable is set.
301     # This way if script is running in jenkins all will be
302     # automatically archived to logs.fd.io.
303     #
304     # Variables read:
305     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
306     #   Can be unset, then it speeds up manual testing.
307     # - ARCHIVE_DIR - Path to directory with content to be copied.
308     # Directories updated:
309     # - ${WORKSPACE}/archives/ - Created if does not exist.
310     #   Content of ${ARCHIVE_DIR}/ is copied here.
311     # Functions called:
312     # - die - Print to stderr and exit.
313
314     set -exuo pipefail
315
316     if [[ -n "${WORKSPACE-}" ]]; then
317         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
318         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
319     fi
320 }
321
322
323 function deactivate_docker_topology () {
324
325     # Deactivate virtual vpp-device topology by removing containers.
326     #
327     # Variables read:
328     # - NODENESS - Node multiplicity of desired testbed.
329     # - FLAVOR - Node flavor string, usually describing the processor.
330
331     set -exuo pipefail
332
333     case_text="${NODENESS}_${FLAVOR}"
334     case "${case_text}" in
335         "1n_skx" | "1n_tx2")
336             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
337             ssh="ssh root@${hostname} -p 6022"
338             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
339             # The "declare -f" output is long and boring.
340             set +x
341             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
342                 die "Topology cleanup via shim-dcr failed!"
343             }
344             set -x
345             ;;
346         "1n_vbox")
347             enter_mutex || die
348             clean_environment || {
349                 die "Topology cleanup locally failed!"
350             }
351             exit_mutex || die
352             ;;
353         *)
354             die "Unknown specification: ${case_text}!"
355     esac
356 }
357
358
359 function die () {
360
361     # Print the message to standard error end exit with error code specified
362     # by the second argument.
363     #
364     # Hardcoded values:
365     # - The default error message.
366     # Arguments:
367     # - ${1} - The whole error message, be sure to quote. Optional
368     # - ${2} - the code to exit with, default: 1.
369
370     set -x
371     set +eu
372     warn "${1:-Unspecified run-time error occurred!}"
373     exit "${2:-1}"
374 }
375
376
377 function die_on_pybot_error () {
378
379     # Source this fragment if you want to abort on any failed test case.
380     #
381     # Variables read:
382     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
383     # Functions called:
384     # - die - Print to stderr and exit.
385
386     set -exuo pipefail
387
388     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
389         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
390     fi
391 }
392
393
394 function generate_tests () {
395
396     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
397     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
398     # The generation is done by executing any *.py executable
399     # within any subdirectory after copying.
400
401     # This is a separate function, because this code is called
402     # both by autogen checker and entries calling run_pybot.
403
404     # Directories read:
405     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
406     # Directories replaced:
407     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
408
409     set -exuo pipefail
410
411     rm -rf "${GENERATED_DIR}/tests" || die
412     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
413     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
414     cmd_line+=("-executable" "-name" "*.py")
415     # We sort the directories, so log output can be compared between runs.
416     file_list=$("${cmd_line[@]}" | sort) || die
417
418     for gen in ${file_list}; do
419         directory="$(dirname "${gen}")" || die
420         filename="$(basename "${gen}")" || die
421         pushd "${directory}" || die
422         ./"${filename}" || die
423         popd || die
424     done
425 }
426
427
428 function get_test_code () {
429
430     # Arguments:
431     # - ${1} - Optional, argument of entry script (or empty as unset).
432     #   Test code value to override job name from environment.
433     # Variables read:
434     # - JOB_NAME - String affecting test selection, default if not argument.
435     # Variables set:
436     # - TEST_CODE - The test selection string from environment or argument.
437     # - NODENESS - Node multiplicity of desired testbed.
438     # - FLAVOR - Node flavor string, usually describing the processor.
439
440     set -exuo pipefail
441
442     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
443     if [[ -z "${TEST_CODE}" ]]; then
444         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
445     fi
446
447     case "${TEST_CODE}" in
448         *"1n-vbox"*)
449             NODENESS="1n"
450             FLAVOR="vbox"
451             ;;
452         *"1n-skx"*)
453             NODENESS="1n"
454             FLAVOR="skx"
455             ;;
456        *"1n-tx2"*)
457             NODENESS="1n"
458             FLAVOR="tx2"
459             ;;
460         *"2n-skx"*)
461             NODENESS="2n"
462             FLAVOR="skx"
463             ;;
464         *"2n-zn2"*)
465             NODENESS="2n"
466             FLAVOR="zn2"
467             ;;
468         *"3n-skx"*)
469             NODENESS="3n"
470             FLAVOR="skx"
471             ;;
472         *"2n-clx"*)
473             NODENESS="2n"
474             FLAVOR="clx"
475             ;;
476         *"2n-dnv"*)
477             NODENESS="2n"
478             FLAVOR="dnv"
479             ;;
480         *"3n-dnv"*)
481             NODENESS="3n"
482             FLAVOR="dnv"
483             ;;
484         *"3n-tsh"*)
485             NODENESS="3n"
486             FLAVOR="tsh"
487             ;;
488         *)
489             # Fallback to 3-node Haswell by default (backward compatibility)
490             NODENESS="3n"
491             FLAVOR="hsw"
492             ;;
493     esac
494 }
495
496
497 function get_test_tag_string () {
498
499     # Variables read:
500     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
501     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
502     # - TEST_CODE - The test selection string from environment or argument.
503     # Variables set:
504     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
505     #   May be empty, or even not set on event types not adding comment.
506
507     # TODO: ci-management scripts no longer need to perform this.
508
509     set -exuo pipefail
510
511     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
512         case "${TEST_CODE}" in
513             *"device"*)
514                 trigger="devicetest"
515                 ;;
516             *"perf"*)
517                 trigger="perftest"
518                 ;;
519             *)
520                 die "Unknown specification: ${TEST_CODE}"
521         esac
522         # Ignore lines not containing the trigger word.
523         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}") || true
524         # The vpp-csit triggers trail stuff we are not interested in.
525         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
526         # (except relying on \s whitespace, \S non-whitespace and . both).
527         # The last string is concatenated, only the middle part is expanded.
528         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
529         # On parsing error, TEST_TAG_STRING probably stays empty.
530         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}") || true
531         if [[ -n "${TEST_TAG_STRING-}" ]]; then
532             test_tag_array=(${TEST_TAG_STRING})
533             if [[ "${test_tag_array[0]}" == "icl" ]]; then
534                 export GRAPH_NODE_VARIANT="icl"
535                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
536             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
537                 export GRAPH_NODE_VARIANT="skx"
538                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
539             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
540                 export GRAPH_NODE_VARIANT="hsw"
541                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
542             fi
543         fi
544     fi
545 }
546
547
548 function installed () {
549
550     # Check if the given utility is installed. Fail if not installed.
551     #
552     # Duplicate of common.sh function, as this file is also used standalone.
553     #
554     # Arguments:
555     # - ${1} - Utility to check.
556     # Returns:
557     # - 0 - If command is installed.
558     # - 1 - If command is not installed.
559
560     set -exuo pipefail
561
562     command -v "${1}"
563 }
564
565
566 function reserve_and_cleanup_testbed () {
567
568     # Reserve physical testbed, perform cleanup, register trap to unreserve.
569     # When cleanup fails, remove from topologies and keep retrying
570     # until all topologies are removed.
571     #
572     # Variables read:
573     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
574     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
575     # - BUILD_TAG - Any string suitable as filename, identifying
576     #   test run executing this function. May be unset.
577     # Variables set:
578     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
579     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
580     # Functions called:
581     # - die - Print to stderr and exit.
582     # - ansible_playbook - Perform an action using ansible, see ansible.sh
583     # Traps registered:
584     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
585
586     set -exuo pipefail
587
588     while true; do
589         for topo in "${TOPOLOGIES[@]}"; do
590             set +e
591             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
592             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
593             python3 "${scrpt}" "${opts[@]}"
594             result="$?"
595             set -e
596             if [[ "${result}" == "0" ]]; then
597                 # Trap unreservation before cleanup check,
598                 # so multiple jobs showing failed cleanup improve chances
599                 # of humans to notice and fix.
600                 WORKING_TOPOLOGY="${topo}"
601                 echo "Reserved: ${WORKING_TOPOLOGY}"
602                 trap "untrap_and_unreserve_testbed" EXIT || {
603                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
604                     untrap_and_unreserve_testbed "${message}" || {
605                         die "Teardown should have died, not failed."
606                     }
607                     die "Trap attempt failed, unreserve succeeded. Aborting."
608                 }
609                 # Cleanup + calibration checks.
610                 set +e
611                 ansible_playbook "cleanup, calibration"
612                 result="$?"
613                 set -e
614                 if [[ "${result}" == "0" ]]; then
615                     break
616                 fi
617                 warn "Testbed cleanup failed: ${topo}"
618                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
619             fi
620             # Else testbed is accessible but currently reserved, moving on.
621         done
622
623         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
624             # Exit the infinite while loop if we made a reservation.
625             warn "Reservation and cleanup successful."
626             break
627         fi
628
629         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
630             die "Run out of operational testbeds!"
631         fi
632
633         # Wait ~3minutes before next try.
634         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
635             die "Sleep time calculation failed."
636         }
637         echo "Sleeping ${sleep_time}"
638         sleep "${sleep_time}" || die "Sleep failed."
639     done
640 }
641
642
643 function run_pybot () {
644
645     # Run pybot with options based on input variables. Create output_info.xml
646     #
647     # Variables read:
648     # - CSIT_DIR - Path to existing root of local CSIT git repository.
649     # - ARCHIVE_DIR - Path to store robot result files in.
650     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
651     # - GENERATED_DIR - Tests are assumed to be generated under there.
652     # Variables set:
653     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
654     # Functions called:
655     # - die - Print to stderr and exit.
656
657     set -exuo pipefail
658
659     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
660     all_options+=("--noncritical" "EXPECTED_FAILING")
661     all_options+=("${EXPANDED_TAGS[@]}")
662
663     pushd "${CSIT_DIR}" || die "Change directory operation failed."
664     set +e
665     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
666     PYBOT_EXIT_STATUS="$?"
667     set -e
668
669     # Generate INFO level output_info.xml for post-processing.
670     all_options=("--loglevel" "INFO")
671     all_options+=("--log" "none")
672     all_options+=("--report" "none")
673     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
674     all_options+=("${ARCHIVE_DIR}/output.xml")
675     rebot "${all_options[@]}" || true
676     popd || die "Change directory operation failed."
677 }
678
679
680 function select_arch_os () {
681
682     # Set variables affected by local CPU architecture and operating system.
683     #
684     # Variables set:
685     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
686     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
687     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
688
689     set -exuo pipefail
690
691     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
692         die "Get OS release failed."
693     }
694
695     case "${os_id}" in
696         "ubuntu"*)
697             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
698             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
699             PKG_SUFFIX="deb"
700             ;;
701         "centos"*)
702             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
703             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
704             PKG_SUFFIX="rpm"
705             ;;
706         *)
707             die "Unable to identify distro or os from ${os_id}"
708             ;;
709     esac
710
711     arch=$(uname -m) || {
712         die "Get CPU architecture failed."
713     }
714
715     case "${arch}" in
716         "aarch64")
717             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
718             ;;
719         *)
720             ;;
721     esac
722 }
723
724
725 function select_tags () {
726
727     # Variables read:
728     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
729     # - TEST_CODE - String affecting test selection, usually jenkins job name.
730     # - DUT - CSIT test/ subdirectory, set while processing tags.
731     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
732     #   Can be unset.
733     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
734     # - BASH_FUNCTION_DIR - Directory with input files to process.
735     # Variables set:
736     # - TAGS - Array of processed tag boolean expressions.
737
738     set -exuo pipefail
739
740     # NIC SELECTION
741     start_pattern='^  TG:'
742     end_pattern='^ \? \?[A-Za-z0-9]\+:'
743     # Remove the TG section from topology file
744     sed_command="/${start_pattern}/,/${end_pattern}/d"
745     # All topologies DUT NICs
746     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
747                 | grep -hoP "model: \K.*" | sort -u)
748     # Selected topology DUT NICs
749     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
750                | grep -hoP "model: \K.*" | sort -u)
751     # All topologies DUT NICs - Selected topology DUT NICs
752     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
753         die "Computation of excluded NICs failed."
754     }
755
756     # Select default NIC tag.
757     case "${TEST_CODE}" in
758         *"3n-dnv"* | *"2n-dnv"*)
759             default_nic="nic_intel-x553"
760             ;;
761         *"3n-tsh"*)
762             default_nic="nic_intel-x520-da2"
763             ;;
764         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
765             default_nic="nic_intel-xxv710"
766             ;;
767         *"3n-hsw"* | *"mrr-daily-master")
768             default_nic="nic_intel-xl710"
769             ;;
770         *)
771             default_nic="nic_intel-x710"
772             ;;
773     esac
774
775     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
776     sed_nics_sub_cmd="sed -e s/ANDxxv710/ANDnic_intel-xxv710/"
777     sed_nics_sub_cmd+=" | sed -e s/ANDx710/ANDnic_intel-x710/"
778     sed_nics_sub_cmd+=" | sed -e s/ANDxl710/ANDnic_intel-xl710/"
779     sed_nics_sub_cmd+=" | sed -e s/ANDx520-da2/ANDnic_intel-x520-da2/"
780     sed_nics_sub_cmd+=" | sed -e s/ANDx553/ANDnic_intel-x553/"
781     sed_nics_sub_cmd+=" | sed -e s/ANDcx556a/ANDnic_mellanox-cx556a/"
782     sed_nics_sub_cmd+=" | sed -e s/ANDvic1227/ANDnic_cisco-vic-1227/"
783     sed_nics_sub_cmd+=" | sed -e s/ANDvic1385/ANDnic_cisco-vic-1385/"
784     # Tag file directory shorthand.
785     tfd="${JOB_SPECS_DIR}"
786     case "${TEST_CODE}" in
787         # Select specific performance tests based on jenkins job type variable.
788         *"ndrpdr-weekly"* )
789             readarray -t test_tag_array <<< $(sed 's/ //g' \
790                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
791                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
792             ;;
793         *"mrr-daily"* )
794             readarray -t test_tag_array <<< $(sed 's/ //g' \
795                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
796                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
797             ;;
798         *"mrr-weekly"* )
799             readarray -t test_tag_array <<< $(sed 's/ //g' \
800                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
801                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
802             ;;
803         *"report-iterative"* )
804             test_sets=(${TEST_TAG_STRING//:/ })
805             # Run only one test set per run
806             report_file=${test_sets[0]}.md
807             readarray -t test_tag_array <<< $(sed 's/ //g' \
808                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
809                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
810             ;;
811         *"report-coverage"* )
812             test_sets=(${TEST_TAG_STRING//:/ })
813             # Run only one test set per run
814             report_file=${test_sets[0]}.md
815             readarray -t test_tag_array <<< $(sed 's/ //g' \
816                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
817                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
818             ;;
819         * )
820             if [[ -z "${TEST_TAG_STRING-}" ]]; then
821                 # If nothing is specified, we will run pre-selected tests by
822                 # following tags.
823                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
824                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
825                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
826                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
827                                 "!dot1q" "!drv_avf")
828             else
829                 # If trigger contains tags, split them into array.
830                 test_tag_array=(${TEST_TAG_STRING//:/ })
831             fi
832             ;;
833     esac
834
835     # Blacklisting certain tags per topology.
836     #
837     # Reasons for blacklisting:
838     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
839     # TODO: Add missing reasons here (if general) or where used (if specific).
840     case "${TEST_CODE}" in
841         *"2n-skx"*)
842             test_tag_array+=("!ipsec")
843             ;;
844         *"3n-skx"*)
845             test_tag_array+=("!ipsechw")
846             # Not enough nic_intel-xxv710 to support double link tests.
847             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
848             ;;
849         *"2n-clx"*)
850             test_tag_array+=("!ipsec")
851             ;;
852         *"2n-zn2"*)
853             test_tag_array+=("!ipsec")
854             ;;
855         *"2n-dnv"*)
856             test_tag_array+=("!ipsechw")
857             test_tag_array+=("!memif")
858             test_tag_array+=("!srv6_proxy")
859             test_tag_array+=("!vhost")
860             test_tag_array+=("!vts")
861             test_tag_array+=("!drv_avf")
862             ;;
863         *"3n-dnv"*)
864             test_tag_array+=("!memif")
865             test_tag_array+=("!srv6_proxy")
866             test_tag_array+=("!vhost")
867             test_tag_array+=("!vts")
868             test_tag_array+=("!drv_avf")
869             ;;
870         *"3n-tsh"*)
871             # 3n-tsh only has x520 NICs which don't work with AVF
872             test_tag_array+=("!drv_avf")
873             test_tag_array+=("!ipsechw")
874             ;;
875         *"3n-hsw"*)
876             test_tag_array+=("!drv_avf")
877             # All cards have access to QAT. But only one card (xl710)
878             # resides in same NUMA as QAT. Other cards must go over QPI
879             # which we do not want to even run.
880             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
881             ;;
882         *)
883             # Default to 3n-hsw due to compatibility.
884             test_tag_array+=("!drv_avf")
885             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
886             ;;
887     esac
888
889     # We will add excluded NICs.
890     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
891
892     TAGS=()
893
894     # We will prefix with perftest to prevent running other tests
895     # (e.g. Functional).
896     prefix="perftestAND"
897     set +x
898     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
899         # Automatic prefixing for VPP jobs to limit the NIC used and
900         # traffic evaluation to MRR.
901         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
902             prefix="${prefix}mrrAND"
903         else
904             prefix="${prefix}mrrAND${default_nic}AND"
905         fi
906     fi
907     for tag in "${test_tag_array[@]}"; do
908         if [[ "${tag}" == "!"* ]]; then
909             # Exclude tags are not prefixed.
910             TAGS+=("${tag}")
911         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
912             # Badly formed tag expressions can trigger way too much tests.
913             set -x
914             warn "The following tag expression hints at bad trigger: ${tag}"
915             warn "Possible cause: Multiple triggers in a single comment."
916             die "Aborting to avoid triggering too many tests."
917         elif [[ "${tag}" == *"OR"* ]]; then
918             # If OR had higher precedence than AND, it would be useful here.
919             # Some people think it does, thus triggering way too much tests.
920             set -x
921             warn "The following tag expression hints at bad trigger: ${tag}"
922             warn "Operator OR has lower precedence than AND. Use space instead."
923             die "Aborting to avoid triggering too many tests."
924         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
925             # Empty and comment lines are skipped.
926             # Other lines are normal tags, they are to be prefixed.
927             TAGS+=("${prefix}${tag}")
928         fi
929     done
930     set -x
931 }
932
933
934 function select_topology () {
935
936     # Variables read:
937     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
938     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
939     # - CSIT_DIR - Path to existing root of local CSIT git repository.
940     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
941     # Variables set:
942     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
943     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
944     # Functions called:
945     # - die - Print to stderr and exit.
946
947     set -exuo pipefail
948
949     case_text="${NODENESS}_${FLAVOR}"
950     case "${case_text}" in
951         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
952         # TODO: Double link availability depends on NIC used.
953         "1n_vbox")
954             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
955             TOPOLOGIES_TAGS="2_node_single_link_topo"
956             ;;
957         "1n_skx" | "1n_tx2")
958             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
959             TOPOLOGIES_TAGS="2_node_single_link_topo"
960             ;;
961         "2n_skx")
962             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
963             TOPOLOGIES_TAGS="2_node_*_link_topo"
964             ;;
965         "3n_skx")
966             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
967             TOPOLOGIES_TAGS="3_node_*_link_topo"
968             ;;
969         "2n_clx")
970             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
971             TOPOLOGIES_TAGS="2_node_*_link_topo"
972             ;;
973         "2n_dnv")
974             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
975             TOPOLOGIES_TAGS="2_node_single_link_topo"
976             ;;
977         "3n_dnv")
978             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
979             TOPOLOGIES_TAGS="3_node_single_link_topo"
980             ;;
981         "3n_hsw")
982             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
983             TOPOLOGIES_TAGS="3_node_single_link_topo"
984             ;;
985         "3n_tsh")
986             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
987             TOPOLOGIES_TAGS="3_node_single_link_topo"
988             ;;
989         *)
990             # No falling back to 3n_hsw default, that should have been done
991             # by the function which has set NODENESS and FLAVOR.
992             die "Unknown specification: ${case_text}"
993     esac
994
995     if [[ -z "${TOPOLOGIES-}" ]]; then
996         die "No applicable topology found!"
997     fi
998 }
999
1000
1001 function select_vpp_device_tags () {
1002
1003     # Variables read:
1004     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1005     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1006     #   Can be unset.
1007     # Variables set:
1008     # - TAGS - Array of processed tag boolean expressions.
1009
1010     set -exuo pipefail
1011
1012     case "${TEST_CODE}" in
1013         # Select specific device tests based on jenkins job type variable.
1014         * )
1015             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1016                 # If nothing is specified, we will run pre-selected tests by
1017                 # following tags. Items of array will be concatenated by OR
1018                 # in Robot Framework.
1019                 test_tag_array=()
1020             else
1021                 # If trigger contains tags, split them into array.
1022                 test_tag_array=(${TEST_TAG_STRING//:/ })
1023             fi
1024             ;;
1025     esac
1026
1027     # Blacklisting certain tags per topology.
1028     #
1029     # Reasons for blacklisting:
1030     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1031     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1032     case "${TEST_CODE}" in
1033         *"1n-vbox"*)
1034             test_tag_array+=("!avf")
1035             test_tag_array+=("!vhost")
1036             ;;
1037         *)
1038             ;;
1039     esac
1040
1041     TAGS=()
1042
1043     # We will prefix with devicetest to prevent running other tests
1044     # (e.g. Functional).
1045     prefix="devicetestAND"
1046     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1047         # Automatic prefixing for VPP jobs to limit testing.
1048         prefix="${prefix}"
1049     fi
1050     for tag in "${test_tag_array[@]}"; do
1051         if [[ ${tag} == "!"* ]]; then
1052             # Exclude tags are not prefixed.
1053             TAGS+=("${tag}")
1054         else
1055             TAGS+=("${prefix}${tag}")
1056         fi
1057     done
1058 }
1059
1060 function untrap_and_unreserve_testbed () {
1061
1062     # Use this as a trap function to ensure testbed does not remain reserved.
1063     # Perhaps call directly before script exit, to free testbed for other jobs.
1064     # This function is smart enough to avoid multiple unreservations (so safe).
1065     # Topo cleanup is executed (call it best practice), ignoring failures.
1066     #
1067     # Hardcoded values:
1068     # - default message to die with if testbed might remain reserved.
1069     # Arguments:
1070     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1071     # Variables read (by inner function):
1072     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1073     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1074     # Variables written:
1075     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1076     # Trap unregistered:
1077     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1078     # Functions called:
1079     # - die - Print to stderr and exit.
1080     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1081
1082     set -xo pipefail
1083     set +eu  # We do not want to exit early in a "teardown" function.
1084     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1085     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1086     if [[ -z "${wt-}" ]]; then
1087         set -eu
1088         warn "Testbed looks unreserved already. Trap removal failed before?"
1089     else
1090         ansible_playbook "cleanup" || true
1091         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1092             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1093         }
1094         WORKING_TOPOLOGY=""
1095         set -eu
1096     fi
1097 }
1098
1099
1100 function warn () {
1101
1102     # Print the message to standard error.
1103     #
1104     # Arguments:
1105     # - ${@} - The text of the message.
1106
1107     set -exuo pipefail
1108
1109     echo "$@" >&2
1110 }